// Define a new application type, each program should derive a class from wxApp
#define APPNAME "BiteSize Reports"
#define VENDNAME "Bite Size, Inc."
//#include "db/BOLTdb.h"

#if defined(__WXGTK__) || defined(__WXMOTIF__)
        #include "wx/wx.h"
#endif
#include <ostream.h>
#include "wx/wxprec.h"
#include <wx/config.h>// (to let wxWindows choose a wxConfig class for your platform)
#include <wx/confbase.h>// (base config class)
//#include <wx/fileconf.h>// (wxFileconfig class)
#include <wx/msw/regconf.h>// (wxRegConfig class)
//#include <wx/msw/iniconf.h>// (wxIniConfig class)
#include <wx/app.h>
#include "wx/tooltip.h"
#include <wx/memory.h>
class BOLTFrame;

//class myConfig;
class myConfig : public wxConfig
{
	public:
  myConfig(const wxString& appName = _T(""),
              const wxString& vendorName = _T(""),
              const wxString& localFilename = _T(""),
              const wxString& globalFilename = _T(""),
              long style = 0): wxConfig(appName,vendorName)
  {};
virtual void Dump(ostream& stream) 
	{	stream << "Dump : myConfig"; }

};

#ifdef __WXDEBUG__
#define safe_delete(x) wxASSERT_MSG(x!=NULL,"Redeleting Memory"); \
	if (x) { delete x; x=NULL; } 
#else
#define safe_delete(x) if (x) { delete x; x=NULL; } 
#endif

class BOLTApp : public wxApp
{
	DECLARE_DYNAMIC_CLASS(BOLTApp)
public:
	virtual void OnFatalException();
	void OnKey(wxKeyEvent &event);
	BOLTFrame *frame;
    // override base class virtuals
    // ----------------------------

    // this one is called on application startup and is a good place for the app
    // initialization (doing it here and not in the ctor allows to have an error
    // return: if OnInit() returns false, the application terminates)
    virtual bool OnInit();
	virtual int OnExit();
	myConfig *config;

virtual void Dump(ostream& stream) 
	{	stream << "Dump : BOLTApp"; }

protected:
	DECLARE_EVENT_TABLE()
};


DECLARE_APP(BOLTApp);

#define SHOW_ERROR(m) wxLogWarning(m)
#define LOG_ERROR(m) wxLogMessage(m)
